#include "iome.xtk.h"

typedef struct {
  KeySym x;
  int iome;
} xKEYMAP;

#define X2IOME_MAP 38
xKEYMAP x2iome[X2IOME_MAP]={
  {XK_BackSpace ,IME_KEY_BACK    },
  {XK_Delete    ,IME_KEY_DELETE  },
  {XK_Escape    ,IME_KEY_ESC     },
  {XK_Tab       ,IME_KEY_TAB     },
  {XK_Return    ,IME_KEY_ENTER   },

  {XK_Home      ,IME_KEY_HOME    },
  {XK_Left      ,IME_KEY_LEFT    },
  {XK_Up        ,IME_KEY_UP      },
  {XK_Right     ,IME_KEY_RIGHT   },
  {XK_Down      ,IME_KEY_DOWN    },

  {XK_Insert    ,IME_KEY_INSERT  },
  {XK_Begin     ,IME_KEY_BEGIN   },
  {XK_End       ,IME_KEY_END     },
  {XK_Next      ,IME_KEY_NEXT    },
  {XK_Page_Up   ,IME_KEY_PAGEUP  },

  {XK_Page_Down ,IME_KEY_PAGEDOWN},
  {XK_F1        ,IME_KEY_F1      },
  {XK_F2        ,IME_KEY_F2      },
  {XK_F3        ,IME_KEY_F3      },
  {XK_F4        ,IME_KEY_F4      },

  {XK_F5        ,IME_KEY_F5      },
  {XK_F6        ,IME_KEY_F6      },
  {XK_F7        ,IME_KEY_F7      },
  {XK_F8        ,IME_KEY_F8      },
  {XK_F9        ,IME_KEY_F9      },

  {XK_F10       ,IME_KEY_F10     },
  {XK_F11       ,IME_KEY_F11     },
  {XK_F12       ,IME_KEY_F12     },
  {XK_KP_0      ,'0'             },
  {XK_KP_1      ,'1'             },

  {XK_KP_2      ,'2'             },
  {XK_KP_3      ,'3'             },
  {XK_KP_4      ,'4'             },
  {XK_KP_5      ,'5'             },
  {XK_KP_6      ,'6'             },

  {XK_KP_7      ,'7'             },
  {XK_KP_8      ,'8'             },
  {XK_KP_9      ,'9'             }
};

int xKeySymToIOME(KeySym ch)
{
  int n;
  for (n=0;n<X2IOME_MAP;n++) 
    if (ch==x2iome[n].x) return x2iome[n].iome;
  return ch;
}

int xKeyStateToIOME(int state)
{
  int US = 0;
  if ((state&ShiftMask))           US|=IME_KF_SHIFT;
  if ((state&(Mod1Mask|Mod5Mask))) US|=IME_KF_ALT;
  if ((state&ControlMask))         US|=IME_KF_CONTROL;
  return US;
}
